program ATOMChanger;

{$APPTYPE CONSOLE}

uses
  SysUtils, Classes, DateUtils, StrUtils,
  INIFiles, Windows;

const
  VERSION = '0.20';

type
  TMoofPos = record
    Pos       : Int64;
    Duration  : Longword;
    traf_num  : Integer;
    trun_num  : Integer;
    smpl_num  : Integer;
  end;
  TDriftItem = record
    Pos       : Int64;
    Ptr       : Longword;
    PosDrift  : Longint;
    PtrDrift  : Longint;
  end;
  TInsertItem = record
    InsertPos : String;
    Last      : Boolean;
    Item      : String;
  end;

var
  DeleteItem   : TStringList;
  InsertItem   : array of TInsertItem;
  Moof         : array of TMoofPos;
  NowDuration  : Longword;
  DurationCnt  : Longword;
  DurationTmp  : Longword;
  ContainItem  : TStringList;
  VideoTrkID   : Integer;
  AudioTrkID   : Integer;
  muxab1,muxab2: Integer;
  muxvb1,muxvb2: Integer;
  audr         : Integer;
  audch        : Integer;
  vidr         : Double;
  vidw,vidh    : Integer;
  NowTrkID     : Integer;
  VideoTScale  : Integer;
  BdefSmplFlg  : Integer;
  defSmplFlg   : Integer;
  BdefDuration : Longword;
  defDuration  : Longword;
  trafCount    : Integer;
  trunCount    : Integer;
  DriftItem    : array of TDriftItem;
  Title        : String;
  mfraMode     : Integer;
  edtsMode     : Boolean;
  dcmdPos      : Int64;
  moovSize     : Longword;
  mqv          : Integer;
  A5504T       : Boolean;
  baseOffset   : Longint;
  creationTime : Longword;
  ForceWidth   : Integer;
  ForceHeight  : Integer;

// ---------------------------------------------------------
//   Tu[`
// ---------------------------------------------------------

procedure WriteAtom(oFH:Integer; siz:Int64; atm:String; buf:Pointer; buflen:Int64);
var
  ch: array [0..3] of Byte;
begin
  ch[0] := (siz div $1000000) and $FF;
  ch[1] := (siz div   $10000) and $FF;
  ch[2] := (siz div     $100) and $FF;
  ch[3] :=  siz               and $FF;
  FIleWrite(oFH,ch,4);
  if (atm <> '')  then FileWrite(oFH,PChar(atm)[0],4);
  if (buf <> nil) then FileWrite(oFH,PChar(buf)[0],bufLen);
end;

function WriteAtomEx(oFH:Integer; dat:String): Int64;
var
  s: Int64;
begin
  s := Length(dat)+4;
  WriteAtom(oFH,s,'',PChar(dat),Length(dat));

  Result := s;
end;

function GetWORD(buf:Pointer; pos:Integer): Longword;
begin
  Result := Ord(PChar(buf)[pos  ])*$100     + Ord(PChar(buf)[pos+1]);
end;

function GetDWORD(buf:Pointer; pos:Integer): Longword;
begin
  Result := Ord(PChar(buf)[pos  ])*$1000000 + Ord(PChar(buf)[pos+1])*$10000 +
            Ord(PChar(buf)[pos+2])*$100     + Ord(PChar(buf)[pos+3]);
end;

procedure SetWORD(buf:Pointer; pos:Integer; p:Longword);
begin
  PChar(buf)[pos  ] := Chr((p div     $100) and $FF);
  PChar(buf)[pos+1] := Chr( p               and $FF);
end;

procedure SetDWORD(buf:Pointer; pos:Integer; p:Longword);
begin
  PChar(buf)[pos  ] := Chr((p div $1000000) and $FF);
  PChar(buf)[pos+1] := Chr((p div   $10000) and $FF);
  PChar(buf)[pos+2] := Chr((p div     $100) and $FF);
  PChar(buf)[pos+3] := Chr( p               and $FF);
end;

function DWORDStr(p:Longword):String;
begin
  Result := Chr((p div $1000000) and $FF)+
            Chr((p div   $10000) and $FF)+
            Chr((p div     $100) and $FF)+
            Chr( p               and $FF);
end;

function WORDStr(p:Longword):String;
begin
  Result := Chr((p div     $100) and $FF)+
            Chr( p               and $FF);
end;


procedure AddDriftPos(buf:Pointer; pos:Integer; ptr:Int64);
var
  i: Integer;
begin
  i := Length(DriftItem);
  setLength(DriftItem,i+1);
  DriftItem[i].Pos      := ptr+pos;
  DriftItem[i].PosDrift := 0;
  DriftItem[i].Ptr      := GetDWORD(buf,pos);
  DriftItem[i].PtrDrift := 0;
end;

procedure DriftPos(start:Int64; drift:Integer);
var
  i: Integer;
begin
  for i:=0 to Length(DriftItem)-1 do
  begin
    if (DriftItem[i].Pos >= start) then DriftItem[i].PosDrift := DriftItem[i].PosDrift + drift;
    if (DriftItem[i].Ptr >= start) then DriftItem[i].PtrDrift := DriftItem[i].PtrDrift + drift;
  end;
end;


// -------------------------------------------------------------------------------
//   ΃AhXLq̐, ^Cg̋zグ, ep[^̓ǂݏo
// -------------------------------------------------------------------------------

procedure ATOMChanger_ScanFile(iFH:Integer; max:Int64; var Title:String; now:String);
var
  start_ptr: Int64;
  ptr,size: Int64;
  ch: array [0..3] of Byte;
  atom,uuid: String;
  i,n,n1,n2,n3,v,w,h: Integer;
  contain,exec: Boolean;
  buf: Pointer;
  p: Longword;
  flg: Word;
  du: Int64;
begin
  start_ptr := FileSeek(iFH,0,1);
  ptr       := 0;

  while(ptr < max) do
  begin
    FileRead(iFH,ch,4);
    size := ch[0] * $1000000 + ch[1] * $10000 + ch[2] * $100 + ch[3];

    // ----- size=0 ُ ... atomI
    if (size<8) then
    begin
      FileSeek(iFH,start_ptr+max,0);
      ptr := max;
    end
      else
    begin
      FileRead(iFH,ch,4);
      atom := Chr(ch[0])+Chr(ch[1])+Chr(ch[2])+Chr(ch[3]);

      // ----- Atom`FbN
      contain := False;
      for i:=0 to ContainItem.Count-1 do if (atom = ContainItem[i]) then contain  := True;

      // ----- 
      if (atom = 'moov') then begin NowTrkID := 0; moovSize := size; end;
      if (contain) and (size>=16) then
      begin
        // ------ qatom`FbNׂH  Kw~
        ATOMChanger_ScanFile(iFH,size-8,Title,Now+atom+'\');
      end
        else
      begin
        // ------ atom
        exec := False;

        // ------ \moov\udta\#251nam  ^Cg
        if ((atom = #251'nam') or (atom = #169'nam')) and (Now = '\moov\udta\') then
        begin
          GetMem(buf,size-8+1);
          try
            FileRead(iFH,PChar(buf)[0],size-8);
            exec := True;
            n := GetWORD(buf,0);  // 
            if (n<>0) then
            begin
              PChar(buf)[4+n] := #00;
              Title := String(PChar(buf)+4);
            end;
          finally
            FreeMem(buf);
          end;
        end;

        // ------ \moov\udta\titl  MobileMP4`^Cg
        if (atom = 'titl') and (Now = '\moov\udta\') then
        begin
          GetMem(buf,size-8+1);
          try
            FileRead(iFH,PChar(buf)[0],size-8);
            exec := True;
            PChar(buf)[size-8] := #00;
            Title := UTF8ToAnsi(UTF8String(PChar(buf)+6));
          finally
            FreeMem(buf);
          end;
        end;

        // ------ uuidprop  EZ[r[`^Cg
        if (atom = 'uuid') and (Now = '\') then
        begin
          GetMem(buf,size-8);
          try
            FileRead(iFH,PChar(buf)[0],size-8);
            exec := True;
            uuid := PChar(buf)[0]+PChar(buf)[1]+PChar(buf)[2]+PChar(buf)[3];
            if (uuid = 'prop') then
            begin
              i := 20;
              while(i<(size-8)) do
              begin
                n := GetDWORD(buf,i);
                uuid := PChar(buf)[i+4]+PChar(buf)[i+5]+PChar(buf)[i+6]+PChar(buf)[i+7];
                if (uuid = 'titl') then
                begin
                  Title := Copy(String(PChar(buf)+i+8),1,n-8);
                end;
                i := i + n;
              end;
            end;
          finally
            FreeMem(buf);
          end;
        end;

        // ------ mvhd  CreationTime`FbN
        if (atom = 'mvhd') then
        begin
          GetMem(buf,size-8);
          try
            FileRead(iFH,PChar(buf)[0],size-8);
            exec := True;
            creationTime := GetDWORD(buf,$4);
          finally
            FreeMem(buf);
          end;
        end;

        // ------ tkhd  TrackID`FbN
        if (atom = 'tkhd') then
        begin
          GetMem(buf,size-8);
          try
            FileRead(iFH,PChar(buf)[0],size-8);
            exec := True;
            NowTrkID := GetDWORD(buf,12);
            w := GetDWORD(buf,$4A);
            h := GetDWORD(buf,$4A+4);
            v := GetWORD(buf,$24);
            if (w<>0) and (h<>0) then
            begin
              if (VideoTrkID <> 0) then
              begin
                writeln('A>Warning: VideoTrack܂');
              end;
              VideoTrkID := NowTrkID;
              vidw := w;
              vidh := h;
            end;
            if (v<>0) then
            begin
              if (AudioTrkID <> 0) then
              begin
                writeln('A>Warning: AudioTrack܂');
              end;
              AudioTrkID := NowTrkID;
            end;
          finally
            FreeMem(buf);
          end;
        end;

        // ------ mdhd  Time scale`FbN
        if (atom = 'mdhd') then
        begin
          GetMem(buf,size-8);
          try
            FileRead(iFH,PChar(buf)[0],size-8);
            exec := True;
            if (NowTrkID = 0) then
            begin
              writeln('A>Warning>mdhd:TrackIDُł');
            end
              else
            begin
              if (VideoTrkID = NowTrkID) then
              begin
                VideoTScale := GetDWORD(buf,$0C);
              end;
            end;
          finally
            FreeMem(buf);
          end;
        end;

        // ------ stts  t[[g`FbN
        if (atom = 'stts') and (NowTrkID = VideoTrkID) then
        begin
          GetMem(buf,size-8);
          try
            FileRead(iFH,PChar(buf)[0],size-8);
            exec := True;
            n  := GetDWORD(buf,$04);
            n3 := 0;
            du := 0;
            for i:=1 to n do
            begin
              n1 := GetDWORD(buf,8+(i-1)*8);
              n2 := GetDWORD(buf,12+(i-1)*8);
              du := du + n1*n2; // duration
              n3 := n3 + n1;    // frame
            end;
            du := du div n3;    // duration per frame
            vidr := VideoTScale / du;
          finally
            FreeMem(buf);
          end;
        end;

        // ------ stsd  esds/rbg[g`FbN
        if (atom = 'stsd') and ((NowTrkID = VideoTrkID) or (NowTrkID = AudioTrkID)) then
        begin
          GetMem(buf,size-8);
          try
            FileRead(iFH,PChar(buf)[0],size-8);
            exec := True;
            n := $5E;
            if (NowTrkID = AudioTrkID) then
            begin
              audr  := GetWORD(buf,$28);  // audio sample rate
              audch := GetWORD(buf,$20);  // audio channels
              n := $2C;
            end;
            n2 := 0;
            for n1:=n to (size-12) do
            begin
              if (PChar(buf)[n1]  ='e') and
                 (PChar(buf)[n1+1]='s') and
                 (PChar(buf)[n1+2]='d') and
                 (PChar(buf)[n1+3]='s') then n2 := n1;
            end;
            if (n2<>0) then
            begin
              // found esds
              n2 := n2 + 8;
              while(n2<size-8) do
              begin
                n := ord(PChar(buf)[n2]);
                case n of
                3:
                  begin
                    n2 := n2 + 1;
                    n1 := ord(PChar(buf)[n2]);
                    if (n1 = $80) then n2 := n2 + 3;
                    n2 := n2 + 4;
                  end;
                4:
                  begin
                    n2 := n2 + 1;
                    n1 := ord(PChar(buf)[n2]);
                    if (n1 = $80) then n2 := n2 + 3;
                    if (NowTrkID = VideoTrkID) then
                    begin
                      muxvb1 := GetDWORD(buf,n2+6);
                      muxvb2 := GetDWORD(buf,n2+10);
                    end
                      else
                    begin
                      muxab1 := GetDWORD(buf,n2+6);
                      muxab2 := GetDWORD(buf,n2+10);
                    end;
                    n2 := size-8;
                  end;
                else
                  begin
                    n2 := size-8;
                  end;
                end;
              end;
            end;

          finally
            FreeMem(buf);
          end;
        end;

        // ------ tfhd  TrackID`FbN,t@Cʒȕ
        if (atom = 'tfhd') then
        begin
          GetMem(buf,size-8);
          try
            FileRead(iFH,PChar(buf)[0],size-8);
            exec := True;
            flg := GetWORD(buf,2);     // tf_flags
            if ((flg and $01) <> 0) then
            begin
              if (not A5504T) then
              begin
                // base-data-offset
                p := GetDWORD(buf,12);
                if (p<>0) then AddDriftPos(buf,12,start_ptr+ptr+8);
                baseOffset := 0;
              end
                else
              begin
                baseOffset := GetDWORD(buf,12);
              end;
            end;
          finally
            FreeMem(buf);
          end;
        end;

        // ------ trun  t@Cʒȕ
        if (atom = 'trun') and (baseOffset<>0) then
        begin
          GetMem(buf,size-8);
          try
            FileRead(iFH,PChar(buf)[0],size-8);
            exec := True;
            flg := GetWORD(buf,2);    // tr_flags
            if ((flg and $01)<>0) then  // data-offset-present
            begin
              // data-offset
              p := Int64(GetDWORD(buf,8)) + baseOffset;
              SetDWORD(buf,8,p);
              AddDriftPos(buf,8,start_ptr+ptr+8);
            end;
          finally
            FreeMem(buf);
          end;
        end;

        // ------ stco  t@Cʒȕ
        if (atom = 'stco') then
        begin
          GetMem(buf,size-8);
          try
            FileRead(iFH,PChar(buf)[0],size-8);
            exec := True;
            n := GetDWORD(buf,4);
            for i:=0 to n-1 do AddDriftPos(buf,8+i*4,start_ptr+ptr+8);
          finally
            FreeMem(buf);
          end;
        end;

        // ------ tfra  t@Cʒȕ
        if (atom = 'tfra') then
        begin
          GetMem(buf,size-8);
          try
            FileRead(iFH,PChar(buf)[0],size-8);
            exec := True;
            // length
            n := GetDWORD(buf,8);
            n1 := ((n shr 4) and 3)+1;
            n2 := ((n shr 2) and 3)+1;
            n3 := ((n      ) and 3)+1;
            // number_of_entry
            n := GetDWORD(buf,12);
            for i:=0 to n-1 do
            begin
              AddDriftPos(buf,20+i*(8+n1+n2+n3),start_ptr+ptr+8);
            end;
          finally
            FreeMem(buf);
          end;
        end;

        // ------ ȊOXLbv
        if (not exec) then FileSeek(iFH,size-8,1);
      end;
      ptr := FileSeek(iFH,0,1) - start_ptr;
    end;
  end;
end;


// ---------------------------------------------------------
//   atom̒ǉ/폜/`FbN
// ---------------------------------------------------------

function ATOMChanger_Execute(iFH,oFH:Integer; max:Int64; Now:String):LongInt;
var
  start_ptr,atom_ptr : Int64;
  temp_ptr,temp_ptr2 : Int64;
  ptr,size           : Int64;
  ch: array [0..3] of Byte;
  atom: String;
  i,j,n,n1,n2,n3,w,h,v: Integer;
  deleting,contain: Boolean;
  buf: Pointer;
  p,dflg: Longword;
  flg: Word;
  drift: Integer;
  dur: Integer;
  s: String;
begin
  start_ptr := FileSeek(iFH,0,1);
  ptr       := 0;
  Result    := 0;    // ԂlatomTCY

  // ----- InsertAtom`FbN(First)
  for i:=0 to Length(InsertItem)-1 do
  begin
    if (InsertItem[i].InsertPos = Now) and (not InsertItem[i].Last) then
    begin
      drift := WriteAtomEx(oFH,InsertItem[i].Item);
      Result := Result + drift;
      DriftPos(start_ptr,drift);
    end;
  end;

  while(ptr < max) do
  begin
    // ----- atomTCY, atom̓ǂݏo
    atom_ptr := FileSeek(iFH,0,1);
    FileRead(iFH,ch,4);
    size := ch[0] * $1000000 + ch[1] * $10000 + ch[2] * $100 + ch[3];
    dur := 0;

    // ----- size=0 ُ ... atomI
    if (size<8) then
    begin
      FileSeek(iFH,start_ptr+max,0);
      ptr := max;
    end
      else
    begin
      FileRead(iFH,ch,4);
      atom := Chr(ch[0])+Chr(ch[1])+Chr(ch[2])+Chr(ch[3]);

      // ----- Atom`FbN
      deleting := (DeleteItem.IndexOf(atom) >= 0);
      contain  := (ContainItem.IndexOf(atom) >= 0);

      // ----- 
      if (deleting) then
      begin
        // 폜
        FileSeek(iFH,size-8,1);
        Result := Result - size;
        DriftPos(atom_ptr,-size);
      end
        else
      begin
        // ------ mfra\zpf[^`FbN
        if (atom = 'moof') then
        begin
          // moof PositionL^
          i := Length(Moof);
          setLength(Moof,i+1);
          NowDuration := NowDuration + DurationCnt;
          Moof[i].Pos := FileSeek(oFH,0,1);
          Moof[i].Duration := NowDuration;
          Moof[i].traf_num := 0;
          Moof[i].trun_num := 0;
          Moof[i].smpl_num := 0;
          trafCount := 0;
          trunCount := 0;
          DurationTmp := 0;
        end;

        if (atom = 'traf') then trafCount := trafCount + 1;

        // ------ [Vpꏊ`FbN
        if (atom = 'dcmd') then
        begin
          if (dcmdPos<>0) then
          begin
            writeln('A>Warning: dcmd atom܂');
          end
            else
          begin
            dcmdPos := FileSeek(oFH,0,1);
          end;
        end;

        if (contain) and (size>=16) then
        begin
          // ------ qatom`FbNׂH  Kw~
          temp_ptr := FileSeek(oFH,0,1);
          WriteAtom(oFH,size,atom,nil,0);
          drift := ATOMChanger_Execute(iFH,oFH,size-8,Now+atom+'\');
          // TCYĂsize
          if (drift <> 0) then
          begin
            temp_ptr2 := FileSeek(oFH,0,1);
            FileSeek(oFH,temp_ptr,0);
            GetMem(buf,4);
            try
              FileRead (oFH,PChar(buf)[0],4);
              SetDWORD(buf,0,Longword(Int64(GetDWORD(buf,0))+drift));
              FileSeek(oFH,-4,1);
              FileWrite(oFH,PChar(buf)[0],4);
            finally
              FreeMem(buf);
            end;
            FileSeek(oFH,temp_ptr2,0);
          end;
          Result := Result + drift;
        end
          else
        begin
          // ------ atom
          GetMem(buf,size-8);
          try
            FileRead(iFH,PChar(buf)[0],size-8);

            // ========== `FbN
            if (atom = 'moov') then
            begin
              NowTrkID := 0;
            end;

            // ------ tkhd  Duration`FbN
            if (atom = 'tkhd') then
            begin
              w := GetDWORD(buf,$4A);
              h := GetDWORD(buf,$4A+4);
              v := GetWORD(buf,$24);
              NowTrkID := GetDWORD(buf,12);
              if (w<>0) or (h<>0) or (v<>0) then
              begin
                dur := GetDWORD(buf,$14);
(*
                // ForceWidth, ForceHeight
                if (ForceWidth<>0)  then SetDWORD(buf,$4A,ForceWidth);
                if (ForceHeight<>0) then SetDWORD(buf,$4E,ForceHeight);
*)
              end;
            end;

(*
            // ------ stsd  ForceWidth,ForceHeight
            if (atom = 'stsd') and (NowTrkID = VideoTrkID) then
            begin
              if (ForceWidth<>0)  then SetWORD(buf,$26,ForceWidth);
              if (ForceHeight<>0) then SetWORD(buf,$28,ForceHeight);
            end;
*)

            // ------ trex  default_sample_flags`FbN
            if (atom = 'trex') then
            begin
              if (VideoTrkID = Integer(GetDWORD(buf,4))) then
              begin
                BdefSmplFlg  := GetDWORD(buf,20);
                defSmplFlg   := BdefSmplFlg;
                BdefDuration := GetDWORD(buf,12);
                defDuration  := BdefDuration;
              end;
            end;

            // ------ mvhd  Duration`FbN
            if (atom = 'mvhd') then DurationCnt := GetDWORD(buf,16);

            // ------ tfhd  TrackID,default_sample_flags`FbN
            if (atom = 'tfhd') then
            begin
              // A5504T[hbase_data_offset0
              flg  := GetWORD(buf,2);
              if (A5504T) and ((flg and $001)<>0) then
              begin
                SetDWORD(buf,12,0);
              end;

              n   := GetDWORD(buf,4);    // TrackID
              if (n = VideoTrkID) then
              begin
                i := Length(Moof) - 1;
                if (i>=0) then Moof[i].traf_num := trafCount;

                // default_sample_flags`FbN
                defSmplFlg  := BdefSmplFlg;
                defDuration := BdefDuration;
                flg  := GetWORD(buf,2);
                n1 := 8;
                n2 := -1;
                n3 := -1;
                if ((flg and $001)<>0) then n1 := n1 + 8; // base_data_offset
                if ((flg and $002)<>0) then n1 := n1 + 4; // sample_description_index
                if ((flg and $008)<>0) then begin n2 := n1; n1 := n1 + 4; end; // default_sample_duration
                if ((flg and $010)<>0) then n1 := n1 + 4; // default_sample_size
                if ((flg and $020)<>0) then n3 := n1;
                if (n2>=0) then defDuration := GetDWORD(buf,n2);
                if (n3>=0) then defSmplFlg  := GetDWORD(buf,n3);
              end;
            end;

            // ------ trun  Duration`FbN,sample_flags`FbN
            if (atom = 'trun') then
            begin
              trunCount := trunCount + 1;
              flg := GetWORD(buf,2);    // tr_flags
              n1 := 8;
              n2 := 0;
              n3 := -1;
              n := GetDWORD(buf,4);                       // sample-count
              if ((flg and $001)<>0) then n1 := n1 + 4;   // data-offset-present
              if ((flg and $004)<>0) then n1 := n1 + 4;   // first-sample-flags
              if ((flg and $100)<>0) then n2 := n2 + 4;   // sample-duration
              if ((flg and $200)<>0) then n2 := n2 + 4;   // sample-size
              if ((flg and $400)<>0) then begin n3 := n2; n2 := n2 + 4; end;  // sample-flags
              if ((flg and $800)<>0) then n2 := n2 + 4;   // sample-composition-time-offsets

              // sample_flags`FbN
              w := Length(Moof)-1;
              h := 0;
              if (w>=0) then
              begin
                if (Moof[w].smpl_num=0) then
                begin
                  if ((flg and $400)<>0) then
                  begin
                    for i:=0 to n-1 do
                    begin
                      dflg := GetDWORD(buf,n1+i*n2+n3);
                      if ((dflg and $10000)=0) then // when 1 signals a non-key or non-sync sample
                      begin
                        h := i+1; break;
                      end;
                    end;
                  end
                    else
                  begin
                    if ((defSmplFlg and $10000)=0) then h := 1;
                  end;
                  if (h<>0) then
                  begin
                    Moof[w].trun_num := trunCount;
                    Moof[w].smpl_num := h;
                    Moof[w].Duration := Moof[w].Duration + DurationTmp;
                    DurationTmp := 0;
                  end;
                end;
              end;

              // Duration`FbN
              for i:=0 to n-1 do
              begin
                if ((flg and $100)<>0) then
                begin
                  if (h>(i+1)) then
                  begin
                    Moof[w].Duration := Moof[w].Duration + GetDWORD(buf,n1+i*n2);
                  end
                    else
                  begin
                    DurationTmp := DurationTmp + GetDWORD(buf,n1+i*n2);
                  end;
                end
                  else
                begin
(*
                  if (mfraMode<>2) then
                  begin
                    if (h>(i+1)) then
                    begin
                      Moof[w].Duration := Moof[w].Duration + defDuration;
                    end
                      else
                    begin
                      DurationTmp := DurationTmp + defDuration;
                    end;
                  end;
*)
                end;
              end;
//            if (mfraMode<>2) or (DurationTmp<>0) then DurationCnt := DurationTmp;
            end;

            WriteAtom(oFH,size,atom,buf,size-8);
          finally
            FreeMem(buf);
          end;
        end;
      end;
      ptr := FileSeek(iFH,0,1) - start_ptr;
    end;

    // ----- edts Insert (tkhď)
    if (edtsMode) and (dur<>0) then
    begin
      atom_ptr := FileSeek(iFH,0,1);    // atomTCYʒu
      s :=     'edts';
      s := s + DWORDStr($1C)+'elst';
      s := s + DWORDStr(0);      // Version,Flags
      s := s + DWORDStr(1);      // Num
      s := s + DWORDStr(dur)+ DWORDStr(0)+DWORDStr($100); // Duration
      drift := WriteAtomEx(oFH,s);
      Result := Result + drift;
      DriftPos(atom_ptr,drift);
    end;
  end;

  // ----- InsertAtom`FbN(Last)
  atom_ptr := FileSeek(iFH,0,1);    // atomTCYʒu
  for i:=0 to Length(InsertItem)-1 do
  begin
    if (InsertItem[i].InsertPos = Now) and (InsertItem[i].Last) then
    begin
      drift := WriteAtomEx(oFH,InsertItem[i].Item);
      Result := Result + drift;
      DriftPos(atom_ptr,drift);
    end;
  end;
end;


// ---------------------------------------------------------
//   ꂽt@CʒȕC
// ---------------------------------------------------------

procedure ATOMChanger_Drift(oFH:Integer);
var
  startpos :Int64;
  i: Integer;
  buf: Pointer;
begin
  startpos := FileSeek(oFH,0,1);
  GetMem(buf,4);
  try
    for i:=0 to Length(DriftItem)-1 do
    begin
      FileSeek(oFH,DriftItem[i].Pos+DriftItem[i].PosDrift,0);
      SetDWORD(buf,0,Longword(Int64(DriftItem[i].Ptr)+DriftItem[i].PtrDrift));
      FileWrite(oFH,PChar(buf)[0],4);
    end;
  finally
    FreeMem(buf);
  end;
  FileSeek(oFH,startpos,0);
end;


// ---------------------------------------------------------
//   mfra̐VK\z
// ---------------------------------------------------------

procedure Build_mfra(oFH,mode:Integer);
var
  buf: Pointer;
  i,n: Integer;
  size1,size2: Integer;
begin
  n := Length(Moof);
  if (n>0) and (VideoTrkID<>0) then
  begin
    size1 := 24+n*11;        // tfra size
    size2 := size1 + 16 + 8; // mfra size
    // mfra
    WriteAtom(oFH,size2,'mfra',nil,0);

    // tfra
    GetMem(buf,size1-8);
    try
      SetDWORD(buf, 0, $00000000);
      SetDWORD(buf, 4, VideoTrkID);
      SetDWORD(buf, 8, $00000000);
      // 
      SetDWORD(buf,12, n);

      // Moof
      for i:=0 to n-1 do
      begin
        SetDWORD(buf,16+i*11, Longword(Moof[i].Duration));
        SetDWORD(buf,20+i*11, Longword(Moof[i].Pos));
        if ((Moof[i].traf_num = 0) or (Moof[i].trun_num = 0) and (Moof[i].smpl_num = 0)) or (mode=2) then
        begin
          PChar(buf)[24+i*11] := #01;
          PChar(buf)[25+i*11] := #01;
          PChar(buf)[26+i*11] := #01;
        end
          else
        begin
          PChar(buf)[24+i*11] := Chr(Moof[i].traf_num);
          PChar(buf)[25+i*11] := Chr(Moof[i].trun_num);
          PChar(buf)[26+i*11] := Chr(Moof[i].smpl_num);
        end;
      end;
      WriteAtom(oFH,size1,'tfra',buf,size1-8);
    finally
      FreeMem(buf);
    end;

    // mfro
    GetMem(buf,8);
    try
      SetDWORD(buf,0,0);
      SetDWORD(buf,4,size2);
      WriteAtom(oFH,16,'mfro',buf,8);
    finally
      FreeMem(buf);
    end;
  end;
end;



// ---------------------------------------------------------
//   URLfR[h
// ---------------------------------------------------------

function URLDecode(s:String):String;
var
  s1: String;
begin
  Result := '';
  while(s<>'') do
  begin
    s1 := Copy(s,1,1);
    s  := Copy(s,2,Length(s));
    if (s1 = '%') then
    begin
      s1 := Copy(s,1,2);
      s  := Copy(s,3,Length(s));
      Result := Result + Chr(StrToIntDef('$'+s1,0));
    end
      else
    begin
      Result := Result + s1;
    end;
  end;
end;

function URLDecodeLen(var s:String; l:Integer):String;
var
  s1: String;
  i: Integer;
begin
  Result := '';
  for i:=1 to l do
  begin
    s1 := Copy(s,1,1);
    s  := Copy(s,2,Length(s));
    if (s1 = '%') then
    begin
      s1 := Copy(s,1,2);
      s  := Copy(s,3,Length(s));
      Result := Result + Chr(StrToIntDef('$'+s1,0));
    end
      else
    begin
      Result := Result + s1;
    end;
  end;
end;


// ---------------------------------------------------------
//   C[`
// ---------------------------------------------------------

var
  EXEName              : String;
  APPName              : String;
  optUsage             : Boolean;
  inputFile,outputFile : String;
  iniFile              : String;

  INI     : TINIFile;
  i,r,n   : Integer;
  s,s1,s2 : String;
  uuid    : String;
  ts      : Int64;
  ts_s    : String;
  daystr  : String;
  desc    : String;
  fdt     : TDateTime;

  iFH,oFH : Integer;
  max     : Int64;
  iMotion : Boolean;
  buf     : Pointer;
  ws      : WideString;
begin
  // R}hC
  EXEName := '';
  if (ParamCount >= 0) then EXEName := ParamStr(0);
  APPName := ChangeFileExt(ExtractFileName(EXEName),'');

  // Opening
  writeln(APPName+' for 3GP_Converter Version '+VERSION);
  writeln('http://www.nurs.or.jp/~calcium/');

  // l
  optUsage     := False;
  inputFile    := '';
  outputFile   := '';
  iniFile      := '';
  daystr       := '1970/01/01 00:00:00';
  NowDuration  := 0;
  DurationCnt  := 0;
  DurationTmp  := 0;
  VideoTrkID   := 0;
  AudioTrkID   := 0;
  NowTrkID     := 0;
  VideoTScale  := 90000;
  vidw         := 160;
  vidh         := 120;
  vidr         := 1.0;
  muxab1       := 1;
  muxab2       := 1;
  muxvb1       := 1;
  muxvb2       := 1;
  audr         := 16000;
  audch        := 1;
  trafCount    := 0;
  trunCount    := 0;
  defSmplFlg   := 0;
  BdefSmplFlg  := 0;
  defDuration  := 0;
  BdefDuration := 0;
  dcmdPos      := 0;
  moovSize     := 0;
  baseOffset   := 0;
  creationTime := 0;
  ForceWidth   := 0;
  ForceHeight  := 0;
  setLength(Moof,0);
  setLength(DriftItem,0);
  setLength(InsertItem,0);

  // ReiƂȂAtom
  ContainItem := TStringList.Create;
  ContainItem.Add('moov');
  ContainItem.Add('trak');
  ContainItem.Add('edts');
  ContainItem.Add('mdia');
  ContainItem.Add('minf');
  ContainItem.Add('dinf');
  ContainItem.Add('stbl');
  ContainItem.Add('mvex');
  ContainItem.Add('moof');
  ContainItem.Add('traf');
  ContainItem.Add('mfra');
  ContainItem.Add('skip');
  ContainItem.Add('udta');
  ContainItem.Add('drm ');

  // 
  i := 1;
  while (i<=ParamCount) do
  begin
    s := ParamStr(i);
    i := i + 1;
    if (Copy(s,1,1)='-') then
    begin
      // Error
      optUsage := True;
    end
      else
    begin
      // fileName
      if (inputFile = '') then
      begin
        inputFile := s;
      end
        else
      begin
        if (outputFile = '') then
        begin
          outputFile := s;
        end
          else
        begin
          if (iniFile = '') then
          begin
            iniFile := s;
          end
            else
          begin
            // Error
            optUsage := True;
          end;
        end;
      end;
    end;
  end;
  if (inputFile = '') or (outputFile = '') then optUsage := True;

  // inputFile Test & default Title
  Title := ChangeFileExt(ExtractFileName(inputFile),'');
  if not FileExists(inputFile) then optUsage := True;

  // 
  if (optUsage) then
  begin
    writeln('');
    writeln('Usage:');
    writeln(APPName + ' [inFile] [outFile] ([iniFile])');
    writeln('  inFileǂݍ݁AatomoutFileɕۑ܂B');
    halt(1);
  end;

  // init@C
  if (iniFile = '') then
  begin
    iniFile := ChangeFileExt(EXEName,'.ini')
  end
    else
  begin
    if (Copy(iniFile,2,1)<>':') and (Copy(iniFile,1,1)<>'\') then
    begin
      iniFile := ExpandFileName(IncludeTrailingPathDelimiter(ExtractFilePath(EXEName))+iniFile);
    end;
  end;

  // iniFile (1: Settings)
  INI := TINIFile.Create(iniFile);
  try
    uuid        := INI.ReadString ('Config','UUID'       ,'');
    mfraMode    := INI.ReadInteger('Config','Build_mfra' ,0);
    edtsMode    := INI.ReadBool   ('Config','Build_edts' ,False);
    mqv         := INI.ReadInteger('Config','MQV'        ,0);
    desc        := INI.ReadString ('Config','Title'      ,'');
    iMotion     := INI.ReadBool   ('Config','iMotion'    ,False);
    A5504T      := INI.ReadBool   ('Config','A5504T'     ,False);
    ForceWidth  := INI.ReadInteger('Config','ForceWidth' ,0);
    ForceHeight := INI.ReadInteger('Config','ForceHeight',0);
  finally
    INI.Free;
  end;

  // Jn(e\)
  writeln(desc);

  // t@Ce
  iFH := FileOpen(inputFile, fmOpenRead);
  if (iFH>=0) then
  begin
    max := FileSeek(iFH,0,2);
    FileSeek(iFH,0,0);
    ATOMChanger_ScanFile(iFH,max,Title,'\');
    FileClose(iFH);
  end;
  // TimeStamp
  if (creationTime=0) then
  begin
    // File Timestamp
    fdt := FileDateToDateTime(FileAge(inputFile));
    creationTime := DateTimeToUnix(fdt) + $7C25B080;
  end;
  ts_s   := '';
  ts_s   :=        '%'+IntToHex((creationTime div $1000000) and $FF, 2);
  ts_s   := ts_s + '%'+IntToHex((creationTime div   $10000) and $FF, 2);
  ts_s   := ts_s + '%'+IntToHex((creationTime div     $100) and $FF, 2);
  ts_s   := ts_s + '%'+IntToHex( creationTime               and $FF, 2);

  fdt    := UnixToDateTime(Int64(creationTime) - $7C25B080);
  daystr := RightStr('000'+IntToStr(YearOf(fdt)),4)+'/'+RightStr('0'+IntToStr(MonthOf(fdt)),2)+'/'+RightStr('0'+IntToStr(DayOf(fdt)),2);
  daystr := daystr + ' ' + RightStr('0'+IntToStr(HourOf(fdt)),2)+':'+RightStr('0'+IntToStr(MinuteOf(fdt)),2)+':'+RightStr('0'+IntToStr(SecondOf(fdt)),2);

  // IniFile (2: Atom Editings)
  DeleteItem := TStringList.Create;
  INI := TINIFile.Create(iniFile);
  try
    DeleteItem.Clear;
    i:=0;
    s:='-';
    while(s<>'') do
    begin
      s := INI.ReadString('DeleteAtom','Item'+IntToStr(i),'');
      if (s<>'') then
      begin
        DeleteItem.Add(URLDecode(s));
      end;
      i := i + 1;
    end;
    if (mfraMode<>0) then
    begin
      DeleteItem.Add('mfra');
    end;
    if (edtsMode) then DeleteItem.Add('edts');

    setLength(InsertItem,0);
    i:=0;
    s:='-';
    while(s<>'') do
    begin
      s := INI.ReadString('InsertAtom','Item'+IntToStr(i),'');
      if (s<>'') then
      begin
        setLength(InsertItem,i+1);
        s := AnsiReplaceText(s,'<%UUID%>',uuid);
        s := AnsiReplaceText(s,'<%TIMESTAMP%>',ts_s);
        InsertItem[i].Last      := (Copy(s,1,1)='/'); // /Ŏn܂ꍇLast
        InsertItem[i].InsertPos := '\';
        // |WVw
        while ((Copy(s,1,1)='\') or (Copy(s,1,1)='/')) do
        begin
          s  := Copy(s,2,Length(s));
          s1 := s;
          s2 := URLDecodeLen(s1,4);
          if ((Copy(s1,1,1)='\') or (Copy(s1,1,1)='/')) then
          begin
            InsertItem[i].InsertPos := InsertItem[i].InsertPos + s2 + '\';
            s := s1;
          end;
        end;
        InsertItem[i].Item := URLDecode(s);
      end;
      i := i + 1;
    end;
  finally
    INI.Free;
  end;

  // -----------------------------------
  //   Jn
  // -----------------------------------

  r := 0;
  iFH := FileOpen(inputFile, fmOpenRead);
  if (iFH>=0) then
  begin
    // ͌ʕ\
    if (VideoTrkID<>0) then
    begin
      writeln('VideoTrack : '+IntToStr(VideoTrkID)+' '+IntToStr(vidw)+' x '+IntToStr(vidh)+' '+FloatToStrF(vidr,ffFixed,5,2)+'fps '+IntToStr(muxvb2)+'bps');
    end;
    if (AudioTrkID<>0) then
    begin
      writeln('AudioTrack : '+IntToStr(AudioTrkID)+' '+IntToStr(audr)+'Hz '+IntToStr(audch)+'ch '+IntToStr(muxab2)+'bps');
    end;

    // MQVȂMQVwb_Insert
    if (mqv=1) then
    begin
      i := Length(InsertItem);
      setLength(InsertItem,i+1);
      InsertItem[i].InsertPos := '\moov\';
      InsertItem[i].Last      := True;
      InsertItem[i].Item      := 'udta';
      s  := Title;
      s1 := #$A9'nam'+WORDStr(Length(s))+#00#00+s;
      s2 := DWORDStr(Length(s1)+4)+s1;
      InsertItem[i].Item      := InsertItem[i].Item + s2;
      s  := daystr;
      s1 := #$A9'day'+WORDStr(Length(s))+#00#00+s;
      s2 := DWORDStr(Length(s1)+4)+s1;
      InsertItem[i].Item      := InsertItem[i].Item + s2;
      s  := '3GP_Converter http://www.nurs.or.jp/~calcium/3gpp/';
      s1 := #$A9'swr'+WORDStr(Length(s))+#00#00+s;
      s2 := DWORDStr(Length(s1)+4)+s1;
      InsertItem[i].Item      := InsertItem[i].Item + s2;
      InsertItem[i].Item      := InsertItem[i].Item + #$00#$00#$00#$08'mqds';
    end;

    // PSPȂPSPwb_Insert
    if (mqv=2) then
    begin
      // Sony uuid
      uuid := #$21#$D2#$4F#$CE#$BB#$88#$69#$5C#$FA#$C9#$C7#$40;

      // moov\uuid
      i := Length(InsertItem);
      setLength(InsertItem,i+1);
      InsertItem[i].InsertPos := '\moov\';
      InsertItem[i].Last      := True;
      InsertItem[i].Item      := 'uuidUSMT'+uuid;
      s  := 'MTDT'+WORDStr(4);

      // und
      s1 := DWORDStr($0B) + WORDStr($55C4); // 'und'
      s1 := s1 + WORDStr(0)+ WORDStr($021C);
      s  := s + WORDStr(Length(s1)+2) + s1;

      // converter
      ws := '3GP_Converter http://www.nurs.or.jp/~calcium/3gpp/';
      s1 := DWORDStr($04) + WORDStr($15C7); // 'eng'
      s1 := s1 + WORDStr(1);
      for n:=1 to Length(ws) do
      begin
        s1 := s1 + chr((Ord(ws[n]) shr 8) and $FF) + chr(Ord(ws[n]) and $FF);
      end;
      s1 := s1 + #0#0;
      s  := s + WORDStr(Length(s1)+2) + s1;

      // Title
      ws := Title;
      s1 := DWORDStr($01) + WORDStr($2A0E); // 'jpn'
      s1 := s1 + WORDStr(1);
      for n:=1 to Length(ws) do
      begin
        s1 := s1 + chr((Ord(ws[n]) shr 8) and $FF) + chr(Ord(ws[n]) and $FF);
      end;
      s1 := s1 + #0#0;
      s  := s + WORDStr(Length(s1)+2) + s1;

      // Day
      ws := daystr;
      s1 := DWORDStr($03) + WORDStr($55C4); // 'und'
      s1 := s1 + WORDStr(1);
      for n:=1 to Length(ws) do
      begin
        s1 := s1 + chr((Ord(ws[n]) shr 8) and $FF) + chr(Ord(ws[n]) and $FF);
      end;
      s1 := s1 + #0#0;
      s  := s + WORDStr(Length(s1)+2) + s1;

      InsertItem[i].Item      := InsertItem[i].Item + DWORDStr(Length(s)+4)+s;

      // \uuid
      i := Length(InsertItem);
      setLength(InsertItem,i+1);
      InsertItem[i].InsertPos := '\';
      InsertItem[i].Last      := False;

      n := 1;
      if (AudioTrkID<>0) then n:=n+1;
      if (VideoTrkID<>0) then n:=n+1;
      InsertItem[i].Item      := 'uuidPROF'+uuid+DWORDStr(0)+DWORDStr(n);

      s1 := 'FPRF'+DWORDStr(0)+DWORDStr(0)+DWORDStr(0);
      s  := DWORDStr(Length(s1)+4)+s1;

      if (AudioTrkID<>0) then
      begin
        s1 :=      'APRF'+DWORDStr(0)+DWORDStr(AudioTrkID)+'mp4a';
        s1 := s1 + DWORDStr($020F);  // @@@FIXME
        s1 := s1 + DWORDStr(0);
        s1 := s1 + DWORDStr(muxab1 div 1000) + DWORDStr(muxab2 div 1000);
        s1 := s1 + DWORDStr(audr)            + DWORDStr(audch);
        s  := s  + DWORDStr(Length(s1)+4)+s1;
      end
        else
      begin
        writeln('A>ϊ̃t@CɃI[fBIgbN܂BɍĐłȂ\܂B');
        r := -2;
      end;

      if (VideoTrkID<>0) then
      begin
        s1 :=      'VPRF'+DWORDStr(0)+DWORDStr(VideoTrkID)+'mp4v';
        s1 := s1 + DWORDStr($01F3);  // @@@FIXME
        s1 := s1 + DWORDStr(0);
        s1 := s1 + DWORDStr(muxvb1 div 1000)   + DWORDStr(muxvb2 div 1000);
        s1 := s1 + DWORDStr(Round(vidr*65536)) + DWORDStr(Round(vidr*65536));
        if (ForceWidth =0) then s1 := s1 + WORDStr(vidw) else s1 := s1 + WORDStr(ForceWidth);
        if (ForceHeight=0) then s1 := s1 + WORDStr(vidh) else s1 := s1 + WORDStr(ForceHeight);
        s1 := s1 + WORDStr(1) + WORDStr(1);
        s  := s  + DWORDStr(Length(s1)+4)+s1;
      end
        else
      begin
        writeln('A>ϊ̃t@CɃrfIgbN܂BɍĐłȂ\܂B');
        r := -2;
      end;
      InsertItem[i].Item      := InsertItem[i].Item + s;

      // moov\trak\uuid
      i := Length(InsertItem);
      setLength(InsertItem,i+1);
      InsertItem[i].InsertPos := '\moov\trak\';
      InsertItem[i].Last      := True;
      InsertItem[i].Item      := 'uuidUSMT'+uuid;
      s1 := 'MTDT'+WORDStr($01);
      s1 := s1 + WORDStr($12);
      s1 := s1 + DWORDStr($0A);
      s1 := s1 + WORDStr($55C4); // und
      s1 := s1 + WORDStr(0) + WORDStr(0) + WORDStr(1) + WORDStr(0) + WORDStr(0);
      InsertItem[i].Item      := InsertItem[i].Item + DWORDStr(Length(s1)+4) + s1;
    end;

    // Pass 2: t@C̃Rs[atomҏW
    oFH := FileCreate(outputFile);
    if (oFH>=0) then
    begin
      max := FileSeek(iFH,0,2);
      FileSeek(iFH,0,0);
      ATOMChanger_Execute(iFH,oFH,max,'\');
      if (mfraMode<>0) and (VideoTrkID<>0) then Build_mfra(oFH,mfraMode);
      ATOMChanger_Drift(oFH);
      FileSetDate(oFH,FileAge(inputFile));
    end
      else
    begin
      writeln('A>'+outputFile+'J܂łB');
      r := -1;
    end;

    // [VݒȂdcmdf[^
    if (iMotion) and (oFH>=0) then
    begin
      if (dcmdPos=0) then
      begin
        writeln('A>Warning: dcmd atom܂');
      end
        else
      begin
        max := FileSeek(oFH,0,2);
        i := $0909;
        if ((max      mod 2)<>0) then i := i or $04;
        if ((moovSize mod 2)<>0) then i := i or $02;
        FileSeek(oFH,dcmdPos+8,0);
        GetMem(buf,2);
        try
          SetWORD(buf,0,i);
          FileWrite(oFH,PChar(buf)[0],2);
        finally
          FreeMem(buf);
        end;
      end;
    end;

    if (iFH>=0) then FileClose(iFH);
    if (oFH>=0) then FileClose(oFH);
  end
    else
  begin
    writeln('A>'+inputFile+'J܂łB');
    r := -1;
  end;

  DeleteItem.Free;
  halt(r);
end.

